unit XMLGenU;

interface

const
  //XML Tags
  XML_MOVIE        = 'movie';
  XML_NUMBER       = 'num';
  XML_TITLE        = 'title';
  XML_ORIGTITLE    = 'origtitle';
  XML_AKA          = 'aka';
  XML_YEAR         = 'year';
  XML_GENRE        = 'genre';
  XML_COUNTRY      = 'country';
  XML_STUDIO       = 'studio';
  XML_RELEASE      = 'release';
  XML_MPAA         = 'mpaa';
  XML_LOCATION     = 'location';
  XML_CATEGORY     = 'category';
  XML_TAGLINE      = 'tagline';
  XML_DESCRIPTION  = 'description';
  XML_MEDIACOUNT   = 'count';
  XML_MEDIATYPE    = 'type';
  XML_RATING       = 'rating';
  XML_IMDBRATING   = 'imdbrating';
  XML_OTHERRATING  = 'orating';
  XML_OTHERNAME    = 'orname';
  XML_RIPTYPE      = 'rip';
  XML_DURATION     = 'length';
  XML_LANGUAGES    = 'langs';
  XML_TRANSLATION  = 'translation';
  XML_RESOLUTION   = 'resolution';
  XML_VIDEOCODEC   = 'videocodec';
  XML_VIDEOBITRATE = 'videobitrate';
  XML_AUDIOCODEC   = 'audiocodec';
  XML_AUDIOBITRATE = 'audiobitrate';
  XML_SIZE         = 'size';
  XML_URL          = 'url';
  XML_PATH         = 'path';
  XML_COMMENT      = 'comment';
  XML_DATE         = 'dateadded';
  XML_BARCODE      = 'code';
  XML_MEDIALABEL   = 'label';
  XML_LOAN         = 'loan';
  XML_SUBS         = 'subs';
  XML_FRAMERATE    = 'framerate';
  XML_LABEL        = 'label';
  XML_FEATURES     = 'features';
  XML_VIEWED       = 'viewed';
  XML_BOOKMARKED   = 'bookmark';
  XML_WISH         = 'wish';
  XML_EPISODES     = 'episodes';
  XML_SEASON       = 'season';
  XML_EPISODE      = 'episode';
  XML_EPNUM        = 'epnum';
  XML_CUSTOMVALUE  = 'custom';
  XML_CUSTOM       = 'value';
  XML_CUSTOMID     = 'customid';
  XML_LOANDATE     = 'loandate';
  XML_VIEWDATE     = 'viewdate';
  XML_TAGS         = 'tags';
  XML_AWARDS       = 'awards';
  XML_EVENT        = 'event';
  XML_RESULT       = 'result';
  XML_AWARD        = 'award';
  XML_AWARD_CAT    = 'cat';
  XML_LINKS        = 'links';
  XML_ACTORS       = 'actors';
  XML_DIRECTORS    = 'directors';
  XML_PRODUCERS    = 'producers';
  XML_COMPOSERS    = 'composers';
  XML_WRITERS      = 'writers';
  XML_CAREERTYPE   = 'careertype';

  XML_HUMAN        = 'human';
  XML_NAME         = 'name';
  XML_TRANSNAME    = 'transname';
  XML_ALTNAMES     = 'altnames';
  XML_BIRTHDAY     = 'birthday';
  XML_BIRTHPLACE   = 'birthplace';
  XML_BIO          = 'bio';
  XML_FILMOGRAPHY  = 'filmography';
  XML_TYPE         = 'category';
  XML_ROLE         = 'role';
  XML_DEATH        = 'death';

  XML_IMAGES       = 'images';
  XML_IMGTYPE      = 'imgtype';
  XML_IMGPATH      = 'imgpath';
  XML_IMGFORMAT    = 'imgformat';
  XML_IMGDATA      = 'imgdata';

  SpecialChars : array [0..2, 0..1] of WideString = (
   ('&', '&amp;'), ('<', '&lt;'), ('>', '&gt;')
  );


 function CreateTag(const TagName, TagData : WideString; doOpen : Boolean = True; doClose : Boolean = True; doPrepare : Boolean = True) : WideString;


implementation

//Escapes not allowed characters
function PrepareXMLString(const AText : WideString) : WideString;
var
 I, J : Integer;
 SpecialFound : Boolean;
begin
 Result := '';
 for I := 1 to Length(AText) do begin
  SpecialFound := False;
  for J := Low(SpecialChars) to High(SpecialChars) do
   if AText[I] = SpecialChars[J, 0] then begin
    Result := Result + SpecialChars[J, 1];
    SpecialFound := True;
    Break;
   end;

   if not SpecialFound then
    Result := Result + AText[I];
 end;
end;

function CreateTag(const TagName, TagData : WideString; doOpen : Boolean; doClose : Boolean; doPrepare : Boolean) : WideString;
begin
 Result := '';

 if doOpen then
  if doPrepare then
   Result := Result + '<' + TagName + '>' + PrepareXMLString(TagData)
  else
   Result := Result + '<' + TagName + '>' + TagData;

 if doClose then
  Result := Result + '</' + TagName + '>' + #13#10;
end;

end.
