library amazon;

uses
  Windows,
  SysUtils,
  Classes,
  ImportU;

const
  PLUGIN_NAME   = 'AMAZON [EN]';
  PLUGIN_DESC_EN   = '[EN] Get Poster from AMAZON.com';
  PLUGIN_DESC_DE   = '[EN] Poster aus AMAZON.com importieren';
  PLUGIN_DESC_RU   = '[EN]    AMAZON.com';
  PLUGIN_DESC_ES   = '[EN] Obtener poster de AMAZON.com';
  PLUGIN_TYPE   = PLUGIN_WEBPICIMPORT;
  PLUGIN_SUPVER = 9008000;
  PLUGIN_VER    = '0.4.3.3';
  PLUGIN_LANG   = LANG_ENGLISH;
  PVD_SUPVER_MIN = 9008000;

  AMAZON_SEARCH_STR = 'http://www.amazon.com/exec/obidos/search-handle-url/index=dvd&field-keywords=%s';


  PARTNER_ID = '?ie=UTF8&tag=persvidedata-20'; 

var
 Selection : array of TSelectionRec;
 Count : Integer = 0;

 curImgURL : String = '';

{$R *.res}

function GetName(const LangID : Integer) : PWideChar; stdcall;
begin
 Result := PLUGIN_NAME;
end;

function GetDescription(const LangID : Integer) : PWideChar; stdcall;
begin
 case LangID of
  LANG_RUSSIAN : Result := PLUGIN_DESC_RU;
  LANG_GERMAN : Result := PLUGIN_DESC_DE;
  LANG_SPANISH : Result := PLUGIN_DESC_ES;
  else
   Result := PLUGIN_DESC_EN;
 end;
end;

function GetType : SHORT; stdcall;
begin
 Result := PLUGIN_TYPE;
end;

function GetPluginLanguage : Integer; stdcall;
begin
 Result := PLUGIN_LANG;
end;

function GetVersionSupported : DWORD; stdcall;
begin
 Result := PLUGIN_SUPVER;
end;

function CheckPVDVerion(const V : Integer) : BOOL; stdcall;
begin
 Result := PVD_SUPVER_MIN <= V;
end;

function GetPluginVersion : PCHAR; stdcall;
begin
 Result := PLUGIN_VER;
end;

function GetURL(const isEpisode : Boolean; const CurrentURL : PCHAR; out NewURL : PCHAR) : Integer; stdcall;
begin
 if curImgURL = '' then begin
  if Pos('amazon.com', LowerCase(CurrentURL)) > 0 then begin
   NewURL := CurrentURL;
   Result := WEB_URL_DIRECT;
  end else begin
   NewURL := AMAZON_SEARCH_STR;
   Result := WEB_URL_SEARCH;
  end;
 end else begin
  NewURL := PCHAR(curImgURL);
  Result := WEB_URL_DIRECT;
 end;
end;

function FindPicture(var HTML : WideString) : Boolean;
var
 P, I : Integer;
begin
 Result := False;

 P := Pos('registerImage("original_image", "', HTML);
 if P <= 0 then
  Exit;

 Delete(HTML, 1, P + Length('registerImage("original_image", "') - 1);

 P := Pos('.jpg"', HTML);
 if P <= 0 then
  Exit;

 for I := P - 1 downto 38 do
  if HTML[I] = '.' then begin
   Delete(HTML, I, Length(HTML) - I + 1);
   Break;
  end;


 Result := True; 
 curImgURL := URLDecode(HTML + '._S300S500_.jpg');
end;

procedure ParseSearchResultsOld(var HTML : WideString);
var
 P, P1 : Integer;
 pURL : WideString;
begin
 curImgURL := '';

 P := Pos('<table class="n2" border="0" cellpadding="0" cellspacing="0">', HTML);
 while P > 0 do begin
  Delete(HTML, 1, P + Length('<table class="n2" border="0" cellpadding="0" cellspacing="0">') - 1);

  pURL := '';

  P1 := Pos('<td class="imageColumn"', HTML);
  if P1 > 0 then begin
   Delete(HTML, 1, P1 + Length('<td class="imageColumn"') - 1);
   P1 := Pos(' src="', HTML);
   if P1 > 0 then begin
    Delete(HTML, 1, P1 + Length(' src="') - 1);
    P1 := Pos('"', HTML);
    if P1 > 0 then begin
     pURL := Copy(HTML, 1, P1 - 1);
     Delete(HTML, 1, P1);
    end;
   end;
  end;


  P1 := Pos('<td class="dataColumn">', HTML);
  if P1 > 0 then begin
   Delete(HTML, 1, P1 + Length('<td class="dataColumn">') - 1);
   P1 := Pos('<a href="', HTML);
   if P1 > 0 then begin
    Delete(HTML, 1, P1 + Length('<a href="') - 1);
    P1 := Pos('?', HTML);
    if P1 > 0 then begin
     Inc(Count);
     SetLength(Selection, Length(Selection) + 1);
     Selection[Length(Selection)-1].URL := Copy(HTML, 1, P1 - 1) + PARTNER_ID;

     if pURL <> '' then
      Selection[Length(Selection)-1].Preview := pURL;

     P1 := Pos('<span class="srTitle">', HTML);
     if P1 > 0 then begin
      Delete(HTML, 1, P1 + Length('<span class="srTitle">') - 1);
      P1 := Pos('</span>', HTML);
      if P1 > 0 then begin
       Selection[Length(Selection)-1].Title := Copy(HTML, 1, P1 - 1);
       Delete(HTML, 1, P1 + Length('</span>') - 1);
      end;
     end;
    end;
   end;
  end;

  P := Pos('<table class="n2" border="0" cellpadding="0" cellspacing="0">', HTML);
 end;
end;

procedure ParseSearchResults(var HTML : WideString);
var
 P, P1 : Integer;
 pURL : WideString;
begin
 curImgURL := '';

 P := Pos('<div class="number">', HTML);
 while P > 0 do begin
  Delete(HTML, 1, P + Length('<div class="number">') - 1);

  pURL := '';

  P1 := Pos('<div class="productImage">', HTML);
  if P1 > 0 then begin
   Delete(HTML, 1, P1 + Length('<div class="productImage">') - 1);
   P1 := Pos(' src="', HTML);
   if P1 > 0 then begin
    Delete(HTML, 1, P1 + Length(' src="') - 1);
    P1 := Pos('"', HTML);
    if P1 > 0 then begin
     pURL := Copy(HTML, 1, P1 - 1);
     Delete(HTML, 1, P1);
    end;
   end;
  end;


  P1 := Pos('<div class="productData">', HTML);
  if P1 > 0 then begin
   Delete(HTML, 1, P1 + Length('<div class="productData">') - 1);
   P1 := Pos('<div class="productTitle">', HTML);
   Delete(HTML, 1, P1 + Length('<div class="productTitle">') - 1);

   P1 := Pos('<a href="', HTML);
   if P1 > 0 then begin
    Delete(HTML, 1, P1 + Length('<a href="') - 1);
    P1 := Pos('?', HTML);
    if P1 > 0 then begin
     Inc(Count);
     SetLength(Selection, Length(Selection) + 1);
     Selection[Length(Selection)-1].URL := Copy(HTML, 1, P1 - 1) + PARTNER_ID;

     if pURL <> '' then
      Selection[Length(Selection)-1].Preview := pURL;

     P1 := Pos('">', HTML);
     Delete(HTML, 1, P1 + Length('">') - 1);
     P1 := Pos('</a>', HTML);
     if P1 > 0 then begin
      Selection[Length(Selection)-1].Title := Copy(HTML, 1, P1 - 1);
      Delete(HTML, 1, P1 + Length('</a>') - 1);
     end;
    end;
   end;
  end;

  P := Pos('<div class="number">', HTML);
 end;
end;

(*
Results:
0 - Error
1 - OK (data extracted)
2 - Movie selection must be shown
*)
function Parse(URL : PCHAR; Data : PWideChar) : SHORT; stdcall;
var
 HTML : WideString;
begin
 Count := 0;
 SetLength(Selection, 0);
 curImgURL := '';

 HTML := Data;
 if (Pos('<span class="noResultsMessage">', HTML) > 0) OR (Pos('did not match any products in:', HTML) > 0) then begin
  Result := PLUGIN_RESPONSE_LIST;
  Exit;
 end else
 if Pos('<div class="resultCount">', HTML) > 0 then begin
  ParseSearchResults(HTML);
  Result := PLUGIN_RESPONSE_LIST;
 end else
 if Pos('<td class="resultCount">', HTML) > 0 then begin
  ParseSearchResultsOld(HTML);
  Result := PLUGIN_RESPONSE_LIST;
 end else begin
  if FindPicture(HTML) then
   Result := PLUGIN_RESPONSE_DOWNLOAD
  else
   Result := PLUGIN_RESPONSE_LIST;
 end;
end;

function GetResultsCount : Integer; stdcall;
begin
 Result := Count;
end;

function GetSelection(const N : Integer; out Title, Title2 : PWideChar; out URL, Preview, Browse : PCHAR; out Year : Smallint) : BOOL; stdcall;
begin
 Result := False;
 if (N > High(Selection)) then
  Exit;

 Result := True;

 Selection[N].Browse := Selection[N].URL;

 Title := PWideChar(Selection[N].Title);
 Title2 := PWideChar(Selection[N].Title2);
 URL := PChar(Selection[N].URL);
 Browse := PChar(Selection[N].Browse);
 Preview := PChar(Selection[N].Preview);
 Year := Selection[N].Year;
end;

function BeginWork : Integer; stdcall;
begin
 Result := 0;

 Count := 0;
 SetLength(Selection, 0);
 curImgURL := '';
end;

procedure EndWork; stdcall;
begin

end;


exports
  BeginWork,
  EndWork,
  GetName,
  GetDescription,
  GetType,
  GetVersionSupported,
  GetPluginVersion,
  Parse,
  GetResultsCount,
  GetSelection,
  GetURL,
  GetPluginLanguage,
  CheckPVDVerion;

begin

end.
