unit csvConfigFormU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TntForms, StdCtrls, Buttons, TntButtons, TntStdCtrls;

type
  TcsvConfigForm = class(TTntForm)
    CatList: TTntListBox;
    AddBtn: TTntBitBtn;
    DelBtn: TTntBitBtn;
    SelList: TTntListBox;
    UpBtn: TTntBitBtn;
    DownBtn: TTntBitBtn;
    OptsGroup: TTntGroupBox;
    DelimLbl: TTntLabel;
    DelimEdit: TEdit;
    QualLbl: TTntLabel;
    QualEdit: TEdit;
    IgnoreCheck: TTntCheckBox;
    TntButton1: TTntButton;
    TntButton2: TTntButton;
    procedure AddBtnClick(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    function Delimiter : Char;
    function Qualifier : Char;
  end;

var
  csvConfigForm: TcsvConfigForm;

implementation

{$R *.DFM}

procedure TcsvConfigForm.AddBtnClick(Sender: TObject);
begin
 if CatList.ItemIndex < 0 then
  Exit;

 if (CatList.ItemIndex = CatList.Count - 1) OR (SelList.Items.IndexOf(CatList.Items[CatList.ItemIndex]) < 0) then
  SelList.Items.Add(CatList.Items[CatList.ItemIndex]);
end;

procedure TcsvConfigForm.DelBtnClick(Sender: TObject);
begin
 if SelList.ItemIndex < 0 then
  Exit;

 SelList.Items.Delete(SelList.ItemIndex);
end;

function TcsvConfigForm.Delimiter: Char;
begin
 if DelimEdit.Text <> '' then
  Result := DelimEdit.Text[1]
 else
  Result := #0;
end;

procedure TcsvConfigForm.DownBtnClick(Sender: TObject);
var
 N : Integer;
begin
 if (SelList.ItemIndex < 0) OR (SelList.ItemIndex = SelList.Items.Count - 1) then
  Exit;

 N := SelList.ItemIndex;
 SelList.Items.Move(SelList.ItemIndex, SelList.ItemIndex + 1);
 SelList.ItemIndex := N + 1;
end;

function TcsvConfigForm.Qualifier: Char;
begin
 if QualEdit.Text <> '' then
  Result := QualEdit.Text[1]
 else
  Result := #0;
end;

procedure TcsvConfigForm.UpBtnClick(Sender: TObject);
var
 N : Integer;
begin
 if SelList.ItemIndex < 1 then
  Exit;

 N := SelList.ItemIndex;
 SelList.Items.Move(SelList.ItemIndex, SelList.ItemIndex - 1);
 SelList.ItemIndex := N - 1;
end;

end.