﻿library new_movieinfo_plugin;

uses
  Windows,
  SysUtils,
  TntSysUtils,
  ImportU,
  XMLGenU;

const
  PLUGIN_NAME   = 'SiteName'; //Replace
  PLUGIN_DESC_EN   = 'Get Movie Information from SiteName.com'; //Replace
  PLUGIN_DESC_DE   = 'Filmdaten aus SiteName.com importieren'; //Replace
  PLUGIN_DESC_RU   = 'Импортировать информацио о фильме из SiteName.com'; //Replace
  PLUGIN_DESC_ES   = 'Obtener información de película de SiteName.com'; //Replace
  PLUGIN_TYPE   = PLUGIN_WEBIMPORT;
  PLUGIN_SUPVER = 9008000;
  PLUGIN_VER    = '0.1.0.0';
  PLUGIN_LANG   = LANG_ENGLISH; //Replace if needed
  PVD_SUPVER_MIN = 9008000;

  SITE_BASE = 'http://www.sitename.com'; //Replace
  SITE_SEARCH_STR = 'http://www.sitename.com'; //Replace

  CODE_PAGE = 1250; //Replace if needed

  RATING_STR = 'SiteName.com'; //Replace

var
 Selection : array of TSelectionRec;
 Movie : TMovieRec;
 Count : Integer = 0;

 URLs : TURLList;

 XML : WideString;


{$R *.res}

function GetName(const LangID : Integer) : PWideChar; stdcall;
begin
 Result := PLUGIN_NAME;
end;

function GetDescription(const LangID : Integer) : PWideChar; stdcall;
begin
 case LangID of
  LANG_RUSSIAN : Result := PLUGIN_DESC_RU;
  LANG_GERMAN : Result := PLUGIN_DESC_DE;
  LANG_SPANISH : Result := PLUGIN_DESC_ES;
  else
   Result := PLUGIN_DESC_EN;
 end;
end;

function GetType : SHORT; stdcall;
begin
 Result := PLUGIN_TYPE;
end;

function GetPluginLanguage : Integer; stdcall;
begin
 Result := PLUGIN_LANG;
end;

function GetVersionSupported : DWORD; stdcall;
begin
 Result := PLUGIN_SUPVER;
end;

function CheckPVDVerion(const V : Integer) : BOOL; stdcall;
begin
 Result := PVD_SUPVER_MIN <= V;
end;

function GetPluginVersion : PCHAR; stdcall;
begin
 Result := PLUGIN_VER;
end;

function GetURL(const isEpisode : Boolean; const CurrentURL : PCHAR; out NewURL : PCHAR) : Integer; stdcall;
var
 I : Integer;
 Found : Boolean;
begin
  //Return any url that needs to be downloaded here
  
 Result := WEB_URL_SEARCH;

 Found := False;
 for I := 0 to ParseURLs(CurrentURL, URLs) - 1 do
  if Pos('sitename.com', LowerCase(URLs[I])) > 0 then begin //Replace sitename.com
   Found := True;
   NewURL := PCHAR(URLs[I]);
   Result := WEB_URL_DIRECT;
  end;

 if not Found then begin
  Result := WEB_URL_SEARCH;

  NewURL := SITE_SEARCH_STR;
 end;
end;

function CanConfig : BOOL; stdcall;
begin
 //True if configurable and false if not
end;

function GetReferrer : PCHAR; stdcall;
begin
 Result := SITE_BASE;
end;

function GetCodePage : Cardinal; stdcall;
begin
 Result := CODE_PAGE;
end;

function Configure(const LangID : Integer; AppHandle : HWND; CustomFields : PWideChar) : BOOL; stdcall;
begin

end;

procedure GetLoginInfo(out ScriptURL : PCHAR; out Params : PCHAR); stdcall;
begin
 //Return login parameters
end;

function Parse(URL : PCHAR; Data : PWideChar) : SHORT; stdcall;
var
 S : WideString;
begin
 S := Data;

 //Parse S and set Result to appropriate value
end;

function GetResultsCount : Integer; stdcall;
begin
 Result := Count;
end;

function GetSelection(const N : Integer; out Title, Title2 : PWideChar; out URL, Preview, Browse : PCHAR; out Year : Smallint) : BOOL; stdcall;
begin
 Result := False;
 if (N > High(Selection)) then
  Exit;

 Result := True;

 Title := PWideChar(Selection[N].Title);
 Title2 := PWideChar(Selection[N].Title2);
 URL := PChar(Selection[N].URL);
 Browse := PChar(Selection[N].Browse);
 Preview := PChar(Selection[N].Preview);
 Year := Selection[N].Year;
end;

function GetMovie(const N : Integer; var AMovieInfo : PWideChar) : BOOL; stdcall;
var
 D : Char;
begin
 D := DecimalSeparator;
 DecimalSeparator := '.';

 XML := CreateTag('xml', '', True, False);
 XML := XML + CreateTag('movie', '', True, False);
 if Movie.Title <> '' then
  XML := XML + CreateTag(XML_TITLE, HTMLToText(Movie.Title));
 if Movie.OrigTitle <> '' then
  XML := XML + CreateTag(XML_ORIGTITLE, HTMLToText(Movie.OrigTitle));
 if Movie.Aka <> '' then
  XML := XML + CreateTag(XML_AKA, HTMLToText(Movie.Aka));
 if Movie.Year <> 0 then
  XML := XML + CreateTag(XML_YEAR, IntToStr(Movie.Year), True, True, False);
 if Movie.Genre <> '' then
  XML := XML + CreateTag(XML_GENRE, HTMLToText(Movie.Genre));
 if Movie.Country <> '' then
  XML := XML + CreateTag(XML_COUNTRY, HTMLToText(Movie.Country));
 if Movie.Studio <> '' then
  XML := XML + CreateTag(XML_STUDIO, HTMLToText(Movie.Studio));
 if Movie.MPAA <> '' then
  XML := XML + CreateTag(XML_MPAA, HTMLToText(Movie.MPAA));
 if Movie.Rating <> 0 then begin
  XML := XML + CreateTag(XML_OTHERRATING, FloatToStrSQL(Movie.Rating), True, True, False);
  XML := XML + CreateTag(XML_OTHERNAME, RATING_STR);
 end;
 if Movie.Tags <> '' then
  XML := XML + CreateTag(XML_TAGS, HTMLToText(Movie.Tags));
 if Movie.Tagline <> '' then
  XML := XML + CreateTag(XML_TAGLINE, HTMLToText(Movie.Tagline));
 if Movie.Description <> '' then
  XML := XML + CreateTag(XML_DESCRIPTION, HTMLToText(Movie.Description));
 if Movie.Duration <> 0 then
  XML := XML + CreateTag(XML_DURATION, IntToStr(Movie.Duration * 60));
 if Movie.URL <> '' then
  XML := XML + CreateTag(XML_URL, Movie.URL);
 if Movie.Features <> '' then
  XML := XML + CreateTag(XML_FEATURES, HTMLToText(Movie.Features));

 XML := XML + Movie.Actors;
 XML := XML + Movie.Director;
 XML := XML + Movie.Producer;
 XML := XML + Movie.Scenario;
 XML := XML + Movie.Music;
 XML := XML + Movie.Links;
 XML := XML + Movie.Awards; //ALWAYS PLACE AWARDS AFTER CREDITS!!!
 XML := XML + Movie.Episodes;

 XML := XML + CreateTag('movie', '', False, True) + CreateTag('xml', '', False, True);

 AMovieInfo := PWideChar(XML);

 DecimalSeparator := D;

 Result := True;
end;  

function BeginWork : Integer; stdcall;
begin
 SetLength(Selection, 0);
 Count := 0;

 //Do some aditional initializing here

 Result := ERR_PLUG_OK;
end;

procedure EndWork; stdcall;
begin
 //do some clearing operations, free memory, etc.
end;


exports
  BeginWork,
  EndWork,
  GetName,
  GetDescription,
  GetType,
  GetVersionSupported,
  GetPluginVersion,
  Parse,
  GetResultsCount,
  GetSelection,
  GetMovie,
  GetURL,
  CanConfig,
  GetPluginLanguage,
  Configure,
  GetLoginInfo,
  GetReferrer,
  GetCodePage,
  CheckPVDVerion;

begin
end.
