library new_personinfo_plugin;

uses
  Windows,
  SysUtils,
  TntSysUtils,
  ImportU,
  XMLGenU;

const
  PLUGIN_NAME   = 'SiteName.com'; //Replace
  PLUGIN_DESC_EN   = '[RU] Get Information about People from SiteName.com'; //Replace
  PLUGIN_DESC_DE   = '[RU] Persondaten aus SiteName.com importieren'; //Replace
  PLUGIN_DESC_RU   = '[RU]      SiteName.com'; //Replace
  PLUGIN_TYPE   = PLUGIN_WEBPEOPLEIMPORT;
  PLUGIN_SUPVER = 9008000;
  PLUGIN_VER    = '0.1.0.0';
  PLUGIN_LANG   = LANG_ENGLISH; //Replace if needed
  PVD_SUPVER_MIN = 9008000;

  SITE_BASE = 'http://www.SiteName.com'; //Replace
  SITE_SEARCH_STR = 'http://www.SiteName.com'; //Replace

  CODE_PAGE = 1250; //Replace if needed

var
 Selection : array of TSelectionRec;
 Human : THumanRec;
 Count : Integer = 0;

 PhotoLink : String = '';
 URLs : TURLList;

 XML : WideString;

{$R *.res}

function GetName(const LangID : Integer): PWideChar; stdcall;
begin
 Result := PLUGIN_NAME;
end;

function GetDescription(const LangID : Integer) : PWideChar; stdcall;
begin
 case LangID of
  LANG_RUSSIAN : Result := PLUGIN_DESC_RU;
  LANG_GERMAN : Result := PLUGIN_DESC_DE;
  else
   Result := PLUGIN_DESC_EN;
 end;
end;

function GetType : SHORT; stdcall;
begin
 Result := PLUGIN_TYPE;
end;

function GetVersionSupported : DWORD; stdcall;
begin
 Result := PLUGIN_SUPVER;
end;

function CheckPVDVerion(const V : Integer) : BOOL; stdcall;
begin
 Result := PVD_SUPVER_MIN <= V;
end;

function GetPluginVersion : PCHAR; stdcall;
begin
 Result := PLUGIN_VER;
end;

function GetPluginLanguage : Integer; stdcall;
begin
 Result := PLUGIN_LANG;
end;

function GetURL(const isEpisode : Boolean; const CurrentURL : PCHAR; out NewURL : PCHAR) : Integer; stdcall;
var
 I : Integer;
 Found : Boolean;
begin
 //Return any url that needs to be downloaded here

 Result := WEB_URL_SEARCH;

 Found := False;
 for I := 0 to ParseURLs(CurrentURL, URLs) - 1 do
  if Pos('SiteName.com', LowerCase(URLs[I])) > 0 then begin //Replace
   Found := True;
   NewURL := PCHAR(URLs[I]);
   Result := WEB_URL_DIRECT;
  end;

 if not Found then begin
  Result := WEB_URL_SEARCH;

  NewURL := SITE_SEARCH_STR;
 end;
end;

function CanConfig : BOOL; stdcall;
begin
 //True if configurable and false if not
end;

function Configure(const LangID : Integer; AppHandle : HWND; CustomFields : PWideChar) : BOOL; stdcall;
begin

end;

procedure GetLoginInfo(out ScriptURL : PCHAR; out Params : PCHAR); stdcall;
begin
 //Return login parameters
end;

function GetReferrer : PCHAR; stdcall;
begin
 Result := SITE_BASE;
end;

function GetCodePage : Cardinal; stdcall;
begin
 Result := CODE_PAGE;
end;

function Parse(URL : PCHAR; Data : PWideChar) : SHORT; stdcall;
var
 S : WideString;
begin
 S := Data;

 //Parse S and set Result to appropriate value
end;

function GetResultsCount : Integer; stdcall;
begin
 Result := Count;
end;

function GetSelection(const N : Integer; out Title, Title2 : PWideChar; out URL, Preview, Browse : PCHAR; out Year : Smallint) : BOOL; stdcall;
begin
 Result := False;
 if (N > High(Selection)) then
  Exit;

 Result := True;

 Title := PWideChar(Selection[N].Title);
 Title2 := PWideChar(Selection[N].Title2);
 URL := PChar(Selection[N].URL);
 Browse := PChar(Selection[N].Browse);
 Preview := PChar(Selection[N].Preview);
 Year := Selection[N].Year;
end;

function GetHuman(const N : Integer; var AHumanInfo : PWideChar) : Integer; stdcall;
var
 D : Char;
begin
 D := DecimalSeparator;
 DecimalSeparator := '.';

 XML := CreateTag('xml', '', True, False);
 XML := XML + CreateTag('person', '', True, False);

 if Human.Name <> '' then
  XML := XML + CreateTag(XML_NAME, HTMLToText(Human.Name));
 if Human.TransName <> '' then
  XML := XML + CreateTag(XML_TRANSNAME, HTMLToText(Human.TransName));
 if Human.AltNames <> '' then
  XML := XML + CreateTag(XML_ALTNAMES, HTMLToText(Human.AltNames));
 if Human.Birthday <> '' then
  XML := XML + CreateTag(XML_BIRTHDAY, Human.Birthday);
 if Human.Birthplace <> '' then
  XML := XML + CreateTag(XML_BIRTHPLACE, HTMLToText(Human.Birthplace));
 if Human.DeathDate <> '' then
  XML := XML + CreateTag(XML_DEATH, HTMLToText(Human.DeathDate));
 if Human.Genre <> '' then
  XML := XML + CreateTag(XML_GENRE, HTMLToText(Human.Genre));
 if Human.URL <> '' then
  XML := XML + CreateTag(XML_URL, HTMLToText(Human.URL));
 if Human.Bio <> '' then
  XML := XML + CreateTag(XML_BIO, HTMLToText(Human.Bio));

 XML := XML + Human.Awards;
 XML := XML + Human.Films; 

 XML := XML + CreateTag('person', '', False, True) + CreateTag('xml', '', False, True);

 AHumanInfo := PWideChar(XML);

 DecimalSeparator := D;

 if PhotoLink <> '' then
  Result := PLUGIN_RESPONSE_OKPHOTO
 else
  Result := PLUGIN_RESPONSE_OK;
end;

function BeginWork : Integer; stdcall;
begin
 SetLength(Selection, 0);
 Count := 0;
 PhotoLink := '';

 //Do some aditional initializing here

 Result := ERR_PLUG_OK;
end;

procedure EndWork; stdcall;
begin
 //do some clearing operations, free memory, etc.
end;


exports
  BeginWork,
  EndWork,
  GetName,
  GetDescription,
  GetType,
  GetVersionSupported,
  GetPluginVersion,
  Parse,
  GetResultsCount,
  GetSelection,
  GetHuman,
  GetURL,
  CanConfig,
  Configure,
  GetPluginLanguage,
  GetLoginInfo,
  GetReferrer,
  GetCodePage,
  CheckPVDVerion;

begin
end.
