library new_poster_plugin;

uses
  Windows,
  SysUtils,
  Classes,
  ImportU;

const
  PLUGIN_NAME   = 'SiteName.com'; //Replace
  PLUGIN_DESC_EN   = 'Get Poster from SiteName.com'; //Replace
  PLUGIN_DESC_DE   = 'Poster aus SiteName.com importieren'; //Replace
  PLUGIN_DESC_RU   = '   SiteName.com'; //Replace
  PLUGIN_DESC_ES   = 'Obtener poster de SiteName.com'; //Replace
  PLUGIN_TYPE   = PLUGIN_WEBPICIMPORT;
  PLUGIN_SUPVER = 9008000;
  PLUGIN_VER    = '0.1.0.0';
  PLUGIN_LANG   = LANG_ENGLISH; //Replace if needed
  PVD_SUPVER_MIN = 9008000;

  SITE_SEARCH_STR = 'http://www.SiteName.com'; //Replace

var
 Selection : array of TSelectionRec;
 Count : Integer = 0;

 URLs : TURLList;

{$R *.res}

function GetName(const LangID : Integer) : PWideChar; stdcall;
begin
 Result := PLUGIN_NAME;
end;

function GetDescription(const LangID : Integer) : PWideChar; stdcall;
begin
 case LangID of
  LANG_RUSSIAN : Result := PLUGIN_DESC_RU;
  LANG_GERMAN : Result := PLUGIN_DESC_DE;
  LANG_SPANISH : Result := PLUGIN_DESC_ES;
  else
   Result := PLUGIN_DESC_EN;
 end;
end;

function GetType : SHORT; stdcall;
begin
 Result := PLUGIN_TYPE;
end;

function GetPluginLanguage : Integer; stdcall;
begin
 Result := PLUGIN_LANG;
end;

function GetVersionSupported : DWORD; stdcall;
begin
 Result := PLUGIN_SUPVER;
end;

function CheckPVDVerion(const V : Integer) : BOOL; stdcall;
begin
 Result := PVD_SUPVER_MIN <= V;
end;

function GetPluginVersion : PCHAR; stdcall;
begin
 Result := PLUGIN_VER;
end;

function GetURL(const isEpisode : Boolean; const CurrentURL : PCHAR; out NewURL : PCHAR) : Integer; stdcall;
var
 I : Integer;
 Found : Boolean;
begin
 //Return any url that needs to be downloaded here

 Result := WEB_URL_SEARCH;

 Found := False;
 for I := 0 to ParseURLs(CurrentURL, URLs) - 1 do
  if Pos('SiteName.com', LowerCase(URLs[I])) > 0 then begin //Replace
   Found := True;
   NewURL := PCHAR(URLs[I]);
   Result := WEB_URL_DIRECT;
  end;

 if not Found then begin
  Result := WEB_URL_SEARCH;

  NewURL := SITE_SEARCH_STR;
 end;
end;

function Parse(URL : PCHAR; Data : PWideChar) : SHORT; stdcall;
var
 S : WideString;
begin
 S := Data;

 //Parse S and set Result to appropriate value
end;

function GetResultsCount : Integer; stdcall;
begin
 Result := Count;
end;

function GetSelection(const N : Integer; out Title, Title2 : PWideChar; out URL, Preview, Browse : PCHAR; out Year : Smallint) : BOOL; stdcall;
begin
 Result := False;
 if (N > High(Selection)) then
  Exit;

 Result := True;

 Selection[N].Browse := Selection[N].URL;

 Title := PWideChar(Selection[N].Title);
 Title2 := PWideChar(Selection[N].Title2);
 URL := PChar(Selection[N].URL);
 Browse := PChar(Selection[N].Browse);
 Preview := PChar(Selection[N].Preview);
 Year := Selection[N].Year;
end;

function BeginWork : Integer; stdcall;
begin
 Result := 0;

 //Do some aditional initializing here

 Count := 0;
 SetLength(Selection, 0);
end;

procedure EndWork; stdcall;
begin
 //do some clearing operations, free memory, etc.
end;


exports
  BeginWork,
  EndWork,
  GetName,
  GetDescription,
  GetType,
  GetVersionSupported,
  GetPluginVersion,
  Parse,
  GetResultsCount,
  GetSelection,
  GetURL,
  GetPluginLanguage,
  CheckPVDVerion;

begin

end.
